import random
import time
#小风 @ccdez 二改死妈 公益频道https://t.me/aOuDpMyQGPN

last_names = [
    "李", "王", "张", "刘", "陈", "杨", "黄", "赵", "周", "吴", "孙", "徐", "马", "朱", "胡", "郭", "高", "林", "何", "罗", "蔡", "蒋", "沈", "彭", "曾", "潘", "韦", "任", "姚", "邓", "梁", 
    "宋", "唐", "许", "曹", "邱", "钟", "谭", "姜", "任", "叶", "蒋", "葛", "杜", "冯", "郑", "崔", "金", "高", "邓", "邵", "陆", "汪", "丁", "段", "彭", "雷", "罗", "常", "肖", "魏", 
    "唐", "崔", "韦", "方", "莫", "余", "邵", "唐", "任", "钟", "程", "姚", "黎", "蒋", "邵", "胡", "何", "朱", "郑", "马", "黄", "高", "吴", "杨", "曾", "谢", "朱", "沈", "黄", "高"
]

first_names = ["伟", "芳", "娜", "敏", "静", "丽", "强", "军", "磊", "洋", "娟", "涛", "彬", "东", "国", "鹏", "波", "光", "丽", "飞", "月", "婷", "佳", "美", "琳", "瑞", "琳", "宇", "阳", "豪", "鹏"]
area_codes = {
    "北京市东城区": "110101", "北京市西城区": "110102", "北京市朝阳区": "110105", "北京市丰台区": "110106",
    "上海市黄浦区": "310101", "上海市浦东新区": "310115", "广州市天河区": "440106", "深圳市福田区": "440304",
    "杭州市西湖区": "330106", "成都市武侯区": "510107", "重庆市渝中区": "500103", "武汉市洪山区": "420111",
    "南京市鼓楼区": "320106", "苏州市姑苏区": "320502", "天津市和平区": "120101", "郑州市金水区": "410105",
    "青岛市市南区": "370201", "大连市中山区": "210202", "西安市新城区": "610102", "长沙市芙蓉区": "430102", "哈尔滨市道里区": "230102"
}
streets = ["人民路", "长江路", "解放路", "建设路", "文化路", "和平大道", "幸福街", "阳光路", "西街", "南路", "北大街", "桃花路", "滨海路", "百花路", "紫禁城路", "桂花路", "福民路", "胜利街", "春风路", "朝阳路", "天安门路", "万达路", "合肥路", "中山路"]
communities = ["第一小区", "阳光花园", "城市绿洲", "星辰小镇", "华润社区", "蓝天家园", "金色年代", "新天地小区", "白云花园", "天玺大厦", "万达广场", "锦绣花园", "东风小区", "中环公寓", "名都大厦", "丽景花园", "世纪家园", "幸福小镇", "南山花园", "都市新城", "富贵花园", "富华大厦", "摩天大楼"]
phone_prefixes = ["138", "139", "136", "137", "135", "150", "151", "152", "157", "158", "159", "186", "187", "130", "131", "133", "134", "189", "185", "180", "181", "182"]
cities = ["北京", "上海", "广州", "深圳", "杭州", "成都", "重庆", "武汉", "南京", "苏州", "郑州", "天津", "青岛", "沈阳", "西安", "长沙", "哈尔滨", "大连", "厦门", "合肥"]

def generate_id_card(region_name, birth_year=None):
    area_code = area_codes[region_name]
    if not birth_year:
        birth_year = random.randint(1960, 2005)  
    birth_date = f"{birth_year}{random.randint(1, 12):02d}{random.randint(1, 28):02d}"
    sequence = f"{random.randint(100, 999)}"
    checksum = str(random.randint(0, 9)) if random.random() > 0.1 else "X"
    return f"{area_code}{birth_date}{sequence}{checksum}"

def generate_phone():
    return f"{random.choice(phone_prefixes)}{random.randint(10000000, 99999999)}"

def generate_name(last_name):
    return f"{last_name}{random.choice(first_names)}"
def generate_address(region_name):
    street = random.choice(streets)
    community = random.choice(communities)
    building = f"{random.randint(1, 20)}栋{random.randint(1, 50)}单元"
    return f"{region_name}{street}{community}{building}"

def generate_family(father_last_name, region_name):
    family_size = random.randint(1, 3)
    mother_last_name = random.choice([name for name in last_names if name != father_last_name]) 
    members = []
    
    
    father_name = generate_name(father_last_name)
    father_phone = generate_phone()
    father_id_card = generate_id_card(region_name, random.randint(1960, 1975))
    members.append({
        "name": father_name,
        "phone": father_phone,
        "id_card": father_id_card
    })
    
    
    mother_name = generate_name(mother_last_name)
    mother_phone = generate_phone()
    mother_id_card = generate_id_card(region_name, random.randint(1960, 1975))
    members.append({
        "name": mother_name,
        "phone": mother_phone,
        "id_card": mother_id_card
    })
    
    
    for _ in range(family_size):
        child_last_name = father_last_name  
        child_name = generate_name(child_last_name)
        child_phone = generate_phone()
        child_id_card = generate_id_card(region_name, random.randint(1995, 2005))
        members.append({
            "name": child_name,
            "phone": child_phone,
            "id_card": child_id_card
        })
    
    return {"size": f"{family_size + 2}人", "details": members}


def pretty_print(data):
    print("\n" + "="*30)
    print("小风 搜索结果 小风")
    print("="*30)
    print(f"姓名: {data['name']}")
    print(f"电话: {data['phone']}")
    print(f"身份证: {data['id_card']}")
    print(f"地址: {data['address']}")
    print(f"家庭成员数量: {data['family_size']}")
    print("-"*30)
    print("👨‍👩‍👧‍👦 家庭成员详情 👨‍👩‍👧‍👦")
    print("-"*30)
    for member in data["family_details"]:
        print(f"    姓名: {member['name']}")
        print(f"    电话: {member['phone']}")
        print(f"    身份证: {member['id_card']}")
        print("-"*30)
    print("="*30)

#
def generate_data(input_name, input_phone):
    region_name = random.choice(list(area_codes.keys()))
    father_last_name = input_name[0]  # 
    family = generate_family(father_last_name, region_name)
    
    # 
    user_id_card = generate_id_card(region_name)
    data = {
        "name": input_name,
        "phone": input_phone,
        "id_card": user_id_card,
        "address": generate_address(region_name),
        "family_size": family["size"],
        "family_details": family["details"]
    }
    
    # 
    pretty_print(data)

# 
if __name__ == "__main__":
    print("欢迎使用小风宇宙文全系统!")
    
    # 输入验证：确保姓名和手机号不能为空
    while True:
        input_name = input("\n请输入姓名：").strip()
        if not input_name:
            print("姓名不能为空，请重新输入。")
            continue
        input_phone = input("请输入手机号：").strip()
        if not input_phone:
            print("手机号不能为空，请重新输入。")
            continue
        break  # 如果
    
    print("\n正在检索数据，请稍等...")
    time.sleep(1)  # 
    generate_data(input_name, input_phone)
